<?php defined('SYSPATH') or die('No direct script access.');

class Model_Discipline extends Model
{
    /**
     * @param $id int discipline id
     * @return array data from <tt>view_disciplines</tt> table
     * @throws HTTP_Exception if discipline does not exist
     */
    public static function getInfo($id) {
        $sql = "CALL `GetDisciplineInfo`('$id'); ";
        $info = DB::query(Database::SELECT, $sql)->execute();

        if($info->count() == 0)
            throw HTTP_Exception::factory(404, "Учебная карта дисциплины с ID $id не найдена!");
        return $info->offsetGet(0);
    }


    /**
     * Add new discipline.
     *
     * @param $teacher int teacher id
     * @param $grade int 1-7
     * @param $subject int subject id
     * @param $examType string <tt>exam</tt> or <tt>credit</tt>
     * @param $lectureCount int
     * @param $practiceCount int
     * @param $labCount int
     * @param $department int department id
     * @return Database_Result
     */
    public static function create($teacher, $grade, $subject, $examType, $lectureCount, $practiceCount, $labCount, $department) {
        $sql = "SELECT `AddDiscipline`('$teacher', '$grade', '$subject', '$examType', '$lectureCount', '$practiceCount', '$labCount', '$department') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /** Change grade. */
    public static function changeGrade($DisciplineID, $teacherID, $Grade) {
        $sql = "SELECT `ChangeDisciplineGrade`('$teacherID', '$DisciplineID', '$Grade') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * Check, whether discipline already exists.
     *
     * @param $teacher int teacher id
     * @param $subject int subject id
     * @param $grade int grade num (1-7)
     * @return true, if exists
     */
    public static function exists($teacher, $subject, $grade) {
        $disciplines = Model_Disciplines::ofTeacher($teacher);
        foreach ($disciplines as $d) {
            if ($subject == $d['SubjectID'] && $grade == $d['GradeNum'])
                return true;
        }
        return false;
    }

}